SystemOrganization addCategory: #ConfigurationOfDebuggerModel!

Object subclass: #ConfigurationOfDebuggerModel
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationOfDebuggerModel'!

!ConfigurationOfDebuggerModel class methodsFor: 'private' stamp: 'AndreiChis 1/15/2013 16:31'!
ensureMetacello
        "Bootstrap Gofer (if necessary), load latest mcz file for ConfigurationOfMetacello (using old 
         Gofer API), then load the latest version of Metacello itself."

        Smalltalk at: #MetacelloProject ifAbsent: [ | error |
                "list of repositories to try, in case primary repository is not accessible"
                (Array 
                        with: 'http://www.squeaksource.com/MetacelloRepository' 
                        with: 'http://seaside.gemstone.com/ss/metacello') do: [:repositoryUrl |
                                ([
                                        Smalltalk at: #Gofer ifAbsent: [
                                        "Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
                                                self bootstrapPackage: 'Gofer-Core-lr.115' from: repositoryUrl ].
                                        Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
                                                gofer := goferClass new
                                                        url: repositoryUrl;
                                                        yourself.
                                                [ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
                                                gofer load ]]
                                                        on: Error
                                                        do: [ :ex |
                                                                error := ex.
                                                                Transcript 
                                                                        cr; 
                                                                        show: 'failed ensureMetacello: ';
                                                                        show: ex description printString;
                                                                        show: '...retrying'.
                                                                "try again"
                                                                ex return: nil ]) ~~ nil
                                        ifTrue: [
                                                "load 'default' group of Metacello"
                                                (Smalltalk at: #ConfigurationOfMetacello) perform: #load.
                                                ^self ]].
                "shouldn't get here unless the load failed ... throw an error"
                self error: 'retry with alternate repository failed: ', error description printString ]! !

!ConfigurationOfDebuggerModel class methodsFor: 'metacello tool support' stamp: 'AndreiChis 1/15/2013 16:33'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfDebuggerModel class methodsFor: 'loading' stamp: 'AndreiChis 1/15/2013 16:36'!
loadDefault
	(self project version: 'default') load! !

!ConfigurationOfDebuggerModel class methodsFor: 'accessing' stamp: 'AndreiChis 1/15/2013 16:32'!
project

	^self new project! !

!ConfigurationOfDebuggerModel methodsFor: 'baselines' stamp: 'AndreiChis 1/15/2013 16:36'!
default: spec 
	<version: 'default'>
	
	spec for: #common do: [
		spec blessing: #default.
		spec repository: 'http://ss3.gemstone.com/ss/DebuggerModel'.
		spec 
			package: 'DebuggerModel'.

		spec group: 'Core' with: #(
			'DebuggerModel') 
	]! !

!ConfigurationOfDebuggerModel methodsFor: 'accessing' stamp: 'AndreiChis 1/15/2013 16:09'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project]! !
